From 29e89084cf2770b57194ca1a2ead936a10b1c54f Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Wed, 20 Oct 2010 22:28:41 +0900
Subject: [PATCH 33/51] check argument type in rb_import_classbox().

---
 eval.c |    6 ++++++
 1 files changed, 6 insertions(+), 0 deletions(-)

diff --git a/eval.c b/eval.c
index b542c93..172774d 100644
--- a/eval.c
+++ b/eval.c
@@ -906,6 +906,12 @@ rb_import_classbox(NODE *cref, VALUE classbox)
     ID id_overlayed_modules;
     VALUE overlayed_modules;
 
+    if (TYPE(classbox) != T_MODULE ||
+	!rb_obj_is_kind_of(classbox, rb_cClassbox)) {
+	rb_raise(rb_eTypeError, "wrong argument type %s (expected Classbox)",
+		 rb_obj_classname(classbox));
+    }
+
     CONST_ID(id_overlayed_modules, "__overlayed_modules__");
     overlayed_modules = rb_attr_get(classbox, id_overlayed_modules);
     if (NIL_P(overlayed_modules)) return;
-- 
1.7.0.4

